diff --git a/content/public/browser/media_data_manager.h b/content/public/browser/media_data_manager.h
new file mode 100644
index 0000000..c259ca8
--- /dev/null
+++ b/content/public/browser/media_data_manager.h
@@ -0,0 +1,43 @@
+// Copyright (c) 2012 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_PUBLIC_BROWSER_MEDIA_DATA_MANAGER_H_
+#define CONTENT_PUBLIC_BROWSER_MEDIA_DATA_MANAGER_H_
+
+#include <list>
+#include <string>
+
+#include "base/callback_forward.h"
+#include "base/process/process.h"
+#include "content/common/content_export.h"
+
+namespace content {
+
+class MediaDataManagerObserver;
+
+// This class is fully thread-safe.
+class MediaDataManager {
+ public:
+  typedef base::Callback<void(const std::list<base::ProcessHandle>&)>
+      GetMediaProcessHandlesCallback;
+
+  // Getter for the singleton.
+  CONTENT_EXPORT static MediaDataManager* GetInstance();
+
+  // Retrieves a list of process handles for all media processes.
+  virtual void GetMediaProcessHandles(
+      const GetMediaProcessHandlesCallback& callback) const = 0;
+
+  // Registers/unregister |observer|.
+  // TODO: useful for stats but unused for now.
+  virtual void AddObserver(MediaDataManagerObserver* observer) = 0;
+  virtual void RemoveObserver(MediaDataManagerObserver* observer) = 0;
+
+ protected:
+  virtual ~MediaDataManager() {}
+};
+
+};  // namespace content
+
+#endif  // CONTENT_PUBLIC_BROWSER_MEDIA_DATA_MANAGER_H_
diff --git a/content/public/browser/media_data_manager_observer.h b/content/public/browser/media_data_manager_observer.h
new file mode 100644
index 0000000..2234dee
--- /dev/null
+++ b/content/public/browser/media_data_manager_observer.h
@@ -0,0 +1,26 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_PUBLIC_BROWSER_MEDIA_DATA_MANAGER_OBSERVER_H_
+#define CONTENT_PUBLIC_BROWSER_MEDIA_DATA_MANAGER_OBSERVER_H_
+
+#include "base/process/kill.h"
+#include "content/common/content_export.h"
+
+namespace content {
+
+// Observers can register themselves via MediaDataManager::AddObserver, and
+// can un-register with MediaDataManager::RemoveObserver.
+class CONTENT_EXPORT MediaDataManagerObserver {
+ public:
+  // Called for any observer when the media process crashed.
+  virtual void OnMediaProcessCrashed(base::TerminationStatus exit_code) {}
+
+ protected:
+  virtual ~MediaDataManagerObserver() {}
+};
+
+};  // namespace content
+
+#endif  // CONTENT_PUBLIC_BROWSER_MEDIA_DATA_MANAGER_OBSERVER_H_
diff --git a/content/public/common/content_switches.cc b/content/public/common/content_switches.cc
index af12206..9b635cc 100644
--- a/content/public/common/content_switches.cc
+++ b/content/public/common/content_switches.cc
@@ -879,6 +879,27 @@ const char kZygoteCmdPrefix[]               = "zygote-cmd-prefix";
 // Causes the process to run as a renderer zygote.
 const char kZygoteProcess[]                 = "zygote";
 
+#if defined(USE_GSTREAMER)
+// Enable GStreamer media backend.
+const char kEnableGStreamerMediaBackend[]   = "enable-gstreamer-media-backend";
+
+// Disable the media process sandbox.
+const char kDisableMediaSandbox[]           = "disable-media-sandbox";
+
+// Extra command line options for launching the media process (normally used
+// for debugging). Use like renderer-cmd-prefix.
+const char kMediaLauncher[]                 = "media-launcher";
+
+// Makes this process a GPU sub-process.
+const char kMediaProcess[]                  = "media-process";
+
+// Causes the media process to display a dialog on launch.
+const char kMediaStartupDialog[]            = "media-startup-dialog";
+
+// Run the GPU process as a thread in the browser process.
+const char kInProcessMedia[]                = "in-process-media";
+#endif
+
 #if defined(ENABLE_WEBRTC)
 // Disables HW decode acceleration for WebRTC.
 const char kDisableWebRtcHWDecoding[]       = "disable-webrtc-hw-decoding";
diff --git a/content/public/common/content_switches.h b/content/public/common/content_switches.h
index 41d43ae..e96268e 100644
--- a/content/public/common/content_switches.h
+++ b/content/public/common/content_switches.h
@@ -257,6 +257,15 @@ CONTENT_EXPORT extern const char kWebRtcStunProbeTrialParameter[];
 extern const char kWebRtcMaxCaptureFramerate[];
 #endif
 
+#if defined(USE_GSTREAMER)
+CONTENT_EXPORT extern const char kEnableGStreamerMediaBackend[];
+CONTENT_EXPORT extern const char kDisableMediaSandbox[];
+extern const char kMediaLauncher[];
+CONTENT_EXPORT extern const char kMediaProcess[];
+CONTENT_EXPORT extern const char kMediaStartupDialog[];
+extern const char kInProcessMedia[];
+#endif
+
 #if defined(OS_ANDROID)
 CONTENT_EXPORT extern const char kDisableGestureRequirementForMediaPlayback[];
 CONTENT_EXPORT extern const char kDisableClickDelay[];
diff --git a/content/public/common/process_type.h b/content/public/common/process_type.h
index 1469669..8396a00 100644
--- a/content/public/common/process_type.h
+++ b/content/public/common/process_type.h
@@ -27,6 +27,9 @@ enum ProcessType {
   PROCESS_TYPE_GPU,
   PROCESS_TYPE_PPAPI_PLUGIN,
   PROCESS_TYPE_PPAPI_BROKER,
+#if defined(USE_GSTREAMER)
+  PROCESS_TYPE_MEDIA,
+#endif
   // Custom process types used by the embedder should start from here.
   PROCESS_TYPE_CONTENT_END,
   // If any embedder has more than 10 custom process types, update this.
diff --git a/content/public/common/sandbox_type.h b/content/public/common/sandbox_type.h
index ef610fb..e35e27c 100644
--- a/content/public/common/sandbox_type.h
+++ b/content/public/common/sandbox_type.h
@@ -28,6 +28,11 @@ enum SandboxType {
   // The PPAPI plugin process.
   SANDBOX_TYPE_PPAPI,
 
+#if defined(USE_GSTREAMER)
+  // media process.
+  SANDBOX_TYPE_MEDIA,
+#endif
+
   SANDBOX_TYPE_AFTER_LAST_TYPE,  // Placeholder to ease iteration.
 };
 
diff --git a/content/renderer/media/audio_decoder.cc b/content/renderer/media/audio_decoder.cc
index c413bb0..805ff03 100644
--- a/content/renderer/media/audio_decoder.cc
+++ b/content/renderer/media/audio_decoder.cc
@@ -31,6 +31,7 @@ bool DecodeAudioFileData(
   if (!destination_bus)
     return false;
 
+#if !defined(MEDIA_DISABLE_FFMPEG)
   // Uses the FFmpeg library for audio file reading.
   InMemoryUrlProtocol url_protocol(reinterpret_cast<const uint8*>(data),
                                    data_size, false);
@@ -89,6 +90,9 @@ bool DecodeAudioFileData(
            << " number of channels: " << number_of_channels;
 
   return actual_frames > 0;
+#else
+  return false;
+#endif
 }
 
 }  // namespace content
